package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.ZB;
import com.sa.ibiz.demo.demo.service.ZBService;
import com.sa.ibiz.demo.demo.service.dto.ZBSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/zb")
public class ZBResource
{
	@Autowired
	private ZBService service;


	@GetMapping(value = "/{id}")
	public ResponseEntity<ZB> get(@Validated @PathVariable String id){
		ZB data=new ZB();
		data.setZbid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("值班[get]操作发生错误","ZB",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<ZB> getDraft(@Validated @RequestBody ZB data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("值班[getDraft]操作发生错误","ZB","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<ZB> remove(@Validated @RequestBody ZB data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("值班[remove]操作发生错误","ZB",data.getZbid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<ZB> create(@Validated @RequestBody ZB data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("值班[create]操作发生错误","ZB",data.getZbid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<ZB> checkKey(@Validated @RequestBody ZB data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("值班[checkKey]操作发生错误","ZB",data.getZbid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<ZB> update(@Validated @RequestBody ZB data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("值班[update]操作发生错误","ZB",data.getZbid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<ZB>> searchDefaultPage(@Validated @RequestBody ZBSearchFilter filter){
		Page<ZB> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<ZB>> listDefault(@Validated @RequestBody ZBSearchFilter filter){
		List<ZB> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
